
stages:
  - build-image
  - validate-template
  - build-app
  - deploy

build-docker-image:
  stage: build-image
  image: docker:latest
  services:
    - docker:dind
  script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
    - docker build --pull -t "$CI_REGISTRY_IMAGE" .
    - docker push "$CI_REGISTRY_IMAGE"
  only:
    changes:
      - Dockerfile
      - branches
      - merge_request
validate:
  stage: validate-template
  image: registry.gitlab.com/desire.bahbioh/samjava
  script:
    - aws configure set aws_access_key_id $KEYID
    - aws configure set aws_secret_access_key $SECRET
    - aws configure set aws_session_token $TOKEN
    - aws configure set default.region us-east-1
    - sam validate
  only:
  - branches
  - merge_request

build-prod:
  stage: build-app
  image: registry.gitlab.com/desire.bahbioh/samjava
  script:
    - aws configure set aws_access_key_id $KEYID
    - aws configure set aws_secret_access_key $SECRET
    - aws configure set aws_session_token $TOKEN
    - aws configure set default.region us-east-1
    - sam build
  artifacts:
    paths:
    - .aws-sam/
  only:
  - branches
  - merge_request
     
deploy-prod:
  stage: deploy
  image: registry.gitlab.com/desire.bahbioh/samjava
  script:
    - aws configure set aws_access_key_id $KEYID
    - aws configure set aws_secret_access_key $SECRET
    - aws configure set aws_session_token $TOKEN
    - aws configure set default.region us-east-1
    - sam deploy --stack-name sam-gitlab-java-$CI_COMMIT_REF_SLUG --s3-bucket dbb-sam-gitlaci-demo --capabilities CAPABILITY_IAM --region us-east-1 --no-confirm-changeset
  only:
  - master
